/* eslint-disable no-param-reassign */
import request from '../utils/request';
import post from '../utils/post';
import config, { cookie } from '../utils/config';
import { getCookie } from '../utils/helper';

export async function fetchDomains(basePath, withRoot = false) {
  if (!basePath) {
    basePath = getCookie(cookie.domainPath);
  }
  const rootDomainInfo = withRoot ? await request(`${config.contextPath}/api/domain/user/info`, { dmPath: basePath }) : null;
  const childrenDomainInfoList = await request(`${config.contextPath}/api/domain/user/children-info`, { dmPath: basePath });
  let infoList;
  if (rootDomainInfo && childrenDomainInfoList) {
    infoList = [
      rootDomainInfo,
      ...childrenDomainInfoList,
    ];
  } else if (rootDomainInfo) {
    infoList = [rootDomainInfo];
  } else if (childrenDomainInfoList) {
    infoList = childrenDomainInfoList;
  } else {
    infoList = [];
  }
  return infoList;
}

export async function switchDomain(path) {
  return post(`${config.contextPath}/api/domain/user/path`, { dmPath: path });
}

export async function currentDomain() {
  return request(`${config.contextPath}/api/domain/user/info`);
}
